DECLARE SUB show (obj() AS ANY, cam AS ANY, lens AS INTEGER)
DECLARE SUB createData (obj() AS ANY, sz AS INTEGER)
DECLARE SUB prnt (text AS STRING)
DECLARE SUB createTable (Table() AS ANY)
DECLARE SUB move (obj() AS ANY, speed AS INTEGER)
DECLARE SUB info ()
DECLARE SUB showBline (obj() AS ANY, cam AS ANY, lens AS INTEGER)
DECLARE SUB smooth (rd AS INTEGER, gr AS INTEGER, bl AS INTEGER)
DECLARE SUB rotate (obj() AS ANY, theta AS ANY)
DECLARE SUB createFont (obj() AS ANY, word AS STRING, sz AS INTEGER)

CONST true = 1, false = 0
CONST LimX = 319, LimY = 199
CONST MidX = LimX \ 2, MidY = LimY \ 2
CONST LetterX = 8, LetterY = 8
CONST ScreenX = 40, ScreenY = 25
CONST byte = 255
CONST intens = 63
CONST DegMax = 51

TYPE pal
  red   AS INTEGER
  green AS INTEGER
  blue  AS INTEGER
END TYPE

TYPE ScreenLine
  x1 AS INTEGER
  y1 AS INTEGER
  x2 AS INTEGER
  y2 AS INTEGER
END TYPE

TYPE WorldPixel
  x AS SINGLE
  y AS SINGLE
  z AS SINGLE
END TYPE

TYPE WorldPixelFPA
  x AS INTEGER
  y AS INTEGER
  z AS INTEGER
END TYPE

TYPE WorldLine
  x1 AS SINGLE
  y1 AS SINGLE
  z1 AS SINGLE
  x2 AS SINGLE
  y2 AS SINGLE
  z2 AS SINGLE
END TYPE

TYPE SinCosValue
  vSin AS SINGLE
  vCos AS SINGLE
END TYPE

DIM MaxLength AS INTEGER
DIM Table(-DegMax TO DegMax) AS SinCosValue
' $DYNAMIC
DIM object(0) AS WorldPixel

SCREEN 13
createTable Table()
info
smooth 2, 3, 3
move object(), 2
END

DATA -157,22,39,-157,-18,39
DATA -157,-18,39,-127,-38,39
DATA -127,-38,39,113,-38,39
DATA 113,-38,39,193,12,39
DATA 33,42,39,33,42,-56
DATA 33,42,-56,-127,42,-56
DATA -127,42,-56,-157,22,-56
DATA -157,22,-56,-157,22,39
DATA -157,22,-56,-157,-18,-56
DATA -157,-18,-56,-157,-18,39
DATA -157,-18,-56,-127,-38,-56
DATA -127,-38,-56,-127,-38,39
DATA -127,-38,-56,113,-38,-56
DATA 113,-38,-56,113,-38,39
DATA 113,-38,-56,193,12,-56
DATA 193,12,-56,193,12,39
DATA -157,22,-56,193,12,-56
DATA 193,12,39,-157,22,39
DATA -56,-13,41,-56,-3,41
DATA -56,-3,41,-26,-3,41
DATA -26,-3,41,-26,7,41
DATA -51,7,41,-31,-13,41
DATA -11,-13,41,-11,-3,41
DATA -11,-3,41,-1,7,41
DATA 9,7,41,9,-8,41
DATA 9,-8,41,24,-8,41
DATA 34,16,41,34,-38,41
DATA 33,-39,41,33,-39,-53
DATA 33,-39,-53,33,15,-53
DATA -42,-38,19,-72,-38,19
DATA -72,-38,19,-72,-38,-41
DATA -72,-38,-41,-42,-38,-41
DATA -42,-38,-41,-42,-38,19
DATA 33,42,39,34,16,41
DATA 33,42,-56,33,15,-53
DATA -157,22,39,-127,42,39
DATA -127,42,-56,-127,42,39
DATA -127,42,39,33,42,39
DATA 159,-8,-56,159,-8,40
DATA 143,-18,-56,143,-18,39
DATA 193,12,39,193,32,30
DATA 33,42,39,193,32,30
DATA 193,32,30,193,32,-47
DATA 33,42,-56,193,32,-47
DATA 193,12,-56,193,32,-47
DATA 1000

REM $STATIC
SUB createData (obj() AS WorldPixel, sz AS INTEGER)

  SHARED MaxLength AS INTEGER
  DIM x AS INTEGER, y AS INTEGER, z AS INTEGER, n AS INTEGER
  DIM nmax AS INTEGER
 
  RESTORE
  FOR n = 0 TO 1000
    READ x
    IF x = 1000 THEN EXIT FOR
    READ y, z
    nmax = nmax + 1
  NEXT
  REDIM obj(nmax + 1) AS WorldPixel
 
  RESTORE
  FOR n = 0 TO nmax - 1
    READ x, y, z
    x = x \ sz: y = y \ sz: z = z \ sz
    IF ABS(x) > MaxLength THEN MaxLength = ABS(x)
    IF ABS(y) > MaxLength THEN MaxLength = ABS(y)
    IF ABS(z) > MaxLength THEN MaxLength = ABS(z)
    obj(n).x = x
    obj(n).y = y
    obj(n).z = z
  NEXT
  MaxLength = MaxLength + 3

END SUB

SUB createFont (obj() AS WorldPixel, word AS STRING, sz AS INTEGER)

  SHARED MaxLength AS INTEGER
  DIM x AS INTEGER, y AS INTEGER, n AS INTEGER
  DIM nmax AS INTEGER

  word = LEFT$(word, 5)
  MaxLength = ((LEN(word) * LetterX) \ 2) * 3 + 3 ' for later camera.z border check

  COLOR 1
  LOCATE 1, 1
  PRINT word

  FOR x = 0 TO LEN(word) * LetterX ' PixelCounter
    FOR y = 0 TO LetterY
      IF POINT(x, y) THEN nmax = nmax + 2
    NEXT
  NEXT
  REDIM obj(nmax + 1) AS WorldPixel

  FOR x = 0 TO LEN(word) * LetterX
    FOR y = 0 TO LetterY
      IF POINT(x, y) THEN
        obj(n).x = (x - (LEN(word) * LetterX) \ 2) * sz
        obj(n).y = (y - LetterY \ 2) * -sz
        obj(n).z = -10
        n = n + 1
        obj(n).x = (x - (LEN(word) * LetterX) \ 2) * sz
        obj(n).y = (y - LetterY \ 2) * -sz
        obj(n).z = 10
        n = n + 1
      END IF
    NEXT
  NEXT
  COLOR 15
  LOCATE 1, 1
  PRINT SPACE$(LEN(word))
 
END SUB

SUB createTable (Table() AS SinCosValue)

  DIM n AS INTEGER
  FOR n = -DegMax TO DegMax
    Table(n).vSin = SIN(n / 100)
    Table(n).vCos = COS(n / 100)
  NEXT

END SUB

SUB info

  LOCATE 1, 1
  prnt "<15>3d freeware demo <9>by Jester 97"
  prnt ""
  prnt "<11>Use <12>arrows<11> for directional movement,"
  prnt "<12>+<11> for forward, <12>-<11> for backward,"
  prnt "<12>e,r,t<11> and <12>d,f,g<11> for"
  prnt "rotation around x,y,z angle."
  prnt "<12>Space<11> switches between the"
  prnt "line-erasing and background mode."
  prnt "<12>Return<11> skips to next object, <12>x<11>"
  prnt "resets object and <12>escape<11> quits."
  prnt ""
  prnt "The data of the first ship was taken"
  prnt "from a program by Rich Geldreich."
  prnt "The method for 3d rotation and the"
  prnt "like can be found in many free online"
  prnt "tutorials. I made sth quite similar in"
  prnt "C++ awhile ago, if youre interested in"
  prnt "that just mail me."
  prnt ""
  prnt "<9>Visit my page at "
  prnt "<7>http://www.geocities.com/"
  prnt "SiliconValley/Lakes/7784"
  DO: LOOP UNTIL INKEY$ <> ""

END SUB

SUB move (obj() AS WorldPixel, speed AS INTEGER)

  SHARED MaxLength AS INTEGER
  DIM cam AS WorldPixel, ObjNr AS INTEGER, Bline AS INTEGER
  DIM theta AS WorldPixelFPA
 
  createData obj(), 5
  cam.z = byte \ 2
 
  DO
    rotate obj(), theta
    IF Bline = true THEN
      showBline obj(), cam, byte
    ELSE
      show obj(), cam, byte
      LOCATE 1
      PRINT cam.x; cam.y; cam.z
    END IF
    keyboard$ = INKEY$
    SELECT CASE keyboard$
      CASE "4", CHR$(0) + "K": IF cam.x > -400 THEN cam.x = cam.x - speed
      CASE "6", CHR$(0) + "M": IF cam.x < 400 THEN cam.x = cam.x + speed
      CASE "8", CHR$(0) + "H": IF cam.y > -400 THEN cam.y = cam.y + speed
      CASE "2", CHR$(0) + "P": IF cam.y < 400 THEN cam.y = cam.y - speed
      CASE "-": IF cam.z < byte - MaxLength THEN cam.z = cam.z + speed
      CASE "+": IF cam.z > MaxLength THEN cam.z = cam.z - speed
      CASE "e": IF theta.x < DegMax THEN theta.x = theta.x + 1
      CASE "r": IF theta.y < DegMax THEN theta.y = theta.y + 1
      CASE "t": IF theta.z < DegMax THEN theta.z = theta.z + 1
      CASE "d": IF theta.x > -DegMax THEN theta.x = theta.x - 1
      CASE "f": IF theta.y > -DegMax THEN theta.y = theta.y - 1
      CASE "g": IF theta.z > -DegMax THEN theta.z = theta.z - 1
      CASE " "
        IF Bline = true THEN
          Bline = false
        ELSE
          Bline = true
          CLS
        END IF
      CASE CHR$(13)
        CLS
        ObjNr = ObjNr + 1
        SELECT CASE ObjNr
          CASE 1: createFont obj(), "-X-", 3
          CASE 2: createFont obj(), "[ o ]", 3
          CASE 3: createFont obj(), "*--*", 3
          CASE 4: createFont obj(), "<-O->", 3
          CASE 5: createFont obj(), "/.+.\", 3
          CASE ELSE: createData obj(), 5: ObjNr = 0
        END SELECT
        CLS
        COLOR 255
      CASE "x"
        cam.x = 0: cam.y = 0: cam.z = byte \ 2
        theta.x = 0: theta.y = 0: theta.z = 0
      CASE CHR$(27): EXIT SUB
    END SELECT
  LOOP

END SUB

SUB prnt (text AS STRING)

  DIM n AS INTEGER, letter AS STRING, col AS STRING
  'LOCATE , INT(ScreenX / 2 - LEN(text) / 2) '?
  FOR n = 1 TO LEN(text)
    letter = MID$(text, n, 1)
    IF letter = "<" THEN
      col = ""
      DO
        n = n + 1
        col = col + MID$(text, n, 1)
      LOOP UNTIL MID$(text, n, 1) = ">"
      COLOR VAL(col)
    ELSE
      PRINT letter;
    END IF
  NEXT
  PRINT

END SUB

SUB rotate (obj() AS WorldPixel, theta AS WorldPixelFPA)

  SHARED Table() AS SinCosValue
  DIM New AS WorldPixel
  FOR n = LBOUND(obj) TO UBOUND(obj)
    New.y = (obj(n).y * Table(theta.x).vCos) - (obj(n).z * Table(theta.x).vSin) ' x
    New.z = (obj(n).z * Table(theta.x).vCos) + (obj(n).y * Table(theta.x).vSin)
    obj(n).y = New.y
    obj(n).z = New.z
    New.x = (obj(n).x * Table(theta.y).vCos) + (obj(n).z * Table(theta.y).vSin) ' y 'sw+-
    New.z = (obj(n).z * Table(theta.y).vCos) - (obj(n).x * Table(theta.y).vSin)
    obj(n).x = New.x
    obj(n).z = New.z
    New.x = (obj(n).x * Table(theta.z).vCos) - (obj(n).y * Table(theta.z).vSin) ' z
    New.y = (obj(n).y * Table(theta.z).vCos) + (obj(n).x * Table(theta.z).vSin)
    obj(n).x = New.x
    obj(n).y = New.y
  NEXT

END SUB

SUB show (obj() AS WorldPixel, cam AS WorldPixel, lens AS INTEGER)

  DIM n AS INTEGER, y AS INTEGER, p AS WorldLine
 
  FOR y = 0 TO 200 STEP 4
    LINE (0, y)-(LimX, y + 3), y, BF
  NEXT

  FOR n = LBOUND(obj) TO UBOUND(obj) - 1 STEP 2
    p.x1 = obj(n).x - cam.x
    p.y1 = obj(n).y - cam.y
    p.z1 = cam.z - obj(n).z
    p.x2 = obj(n + 1).x - cam.x
    p.y2 = obj(n + 1).y - cam.y
    p.z2 = cam.z - obj(n + 1).z
    LINE (MidX + (p.x1 / p.z1) * lens, MidY - (p.y1 / p.z1) * lens)-(MidX + (p.x2 / p.z2) * lens, MidY - (p.y2 / p.z2) * lens), byte - (p.z1 + p.z2) \ 2
  NEXT

END SUB

SUB showBline (obj() AS WorldPixel, cam AS WorldPixel, lens AS INTEGER) STATIC

  DIM OCopy(400) AS ScreenLine, n AS INTEGER, p AS WorldLine
 
  FOR n = LBOUND(obj) TO UBOUND(obj) - 1 STEP 2
    p.x1 = obj(n).x - cam.x
    p.y1 = obj(n).y - cam.y
    p.z1 = cam.z - obj(n).z
    p.x2 = obj(n + 1).x - cam.x
    p.y2 = obj(n + 1).y - cam.y
    p.z2 = cam.z - obj(n + 1).z
    LINE (OCopy(n).x1, OCopy(n).y1)-(OCopy(n).x2, OCopy(n).y2), 0
    OCopy(n).x1 = MidX + (p.x1 / p.z1) * lens
    OCopy(n).y1 = MidY - (p.y1 / p.z1) * lens
    OCopy(n).x2 = MidX + (p.x2 / p.z2) * lens
    OCopy(n).y2 = MidY - (p.y2 / p.z2) * lens
    LINE (OCopy(n).x1, OCopy(n).y1)-(OCopy(n).x2, OCopy(n).y2), byte - (p.z1 + p.z2) \ 2
  NEXT

END SUB

SUB showBowl (obj() AS WorldPixel, cam AS WorldPixel, lens AS INTEGER)

  DIM n AS INTEGER, y AS INTEGER, p AS WorldPixel

  FOR y = 0 TO 200 STEP 4
    LINE (0, y)-(LimX, y + 3), y, BF
  NEXT

  FOR n = LBOUND(obj) TO UBOUND(obj)
    p.x = obj(n).x - cam.x
    p.y = obj(n).y - cam.y
    p.z = cam.z - obj(n).z
    CIRCLE (MidX + (p.x / p.z) * lens, MidY - (p.y / p.z) * lens), lens \ p.z, byte - p.z \ 2
    PAINT STEP(0, 0), byte - p.z \ 2, byte - p.z \ 2
  NEXT

END SUB

SUB smooth (rd AS INTEGER, gr AS INTEGER, bl AS INTEGER)

  DIM colors(byte) AS pal
  DIM n AS INTEGER, z AS INTEGER
  z = intens \ 3
  CLS
  PALETTE byte, 65536 * (intens - 10) + 256 * (intens - 10) + intens - 10
  COLOR byte
  FOR n = 0 TO byte
    colors(n).red = INT(n * ((rd * z) / byte))
    colors(n).green = INT(n * ((gr * z) / byte))
    colors(n).blue = INT(n * ((bl * z) / byte))
    OUT 968, n
    OUT 969, colors(n).red
    OUT 969, colors(n).green
    OUT 969, colors(n).blue
  NEXT
 
END SUB

